import {Component, Input, OnChanges, SimpleChanges} from '@angular/core';

@Component({
  selector: 'app-slider',
  templateUrl: './slider.component.html',
  styleUrls: ['./slider.component.css']
})
export class SliderComponent implements OnChanges{
  @Input() avg: number | undefined = 0;
  @Input() max: number | undefined = 0;
  @Input() min: number | undefined = 0;

  @Input() mType: string = "";


  unitHashMapper = new Map<String, String>([
    ["SOIL_TEMPERATURE", "&#176;"],
    ["SOIL_MOISTURE", "&#37;"],
    ["",""]
  ]);


  distance: number = (this.avg! - this.min!) / (this.max! - this.min!) * 100;

  ngOnChanges(changes: SimpleChanges) {
      this.distance = (this.avg! - this.min!) / (this.max! - this.min!) * 100;
  }
}
