import {Component} from '@angular/core';
import {FormBuilder, FormGroup} from "@angular/forms";
import {HostModel} from "./host.model";
import {ApiService} from "../../../../../shared/api.service";

@Component({
  selector: 'app-host',
  templateUrl: './host.component.html',
  styleUrls: ['./host.component.css']
})
export class HostComponent {

  formHost!: FormGroup;
  hostData!: any;
  host: HostModel = new HostModel();
  showAddButton!: boolean;
  showUpdateButton!: boolean;

  constructor(private api: ApiService, private formBuilder: FormBuilder) {
    this.getAllHosts();
    this.formHost = formBuilder.group({
      name: [''],
      simId: [''],
      mac: [''],
    });
  }

  // get all hosts
  getAllHosts() {
    this.api.get('http://localhost:8080/api/v1/host/all')
      .subscribe(res => {
        this.hostData = res;
      });
  }

// add host
  onAddHost() {
    this.host.name = this.formHost.value.name;
    this.host.simId = this.formHost.value.simId;
    this.host.mac = this.formHost.value.mac;
    this.api.post('http://localhost:8080/api/v1/host/add', this.host)
      .subscribe(res => {
        this.getAllHosts();
        this.formHost.reset();
        alert('Host added successfully');
        document.getElementById('cancel-btn')?.click();
      }, err => {
        alert('An error has occurred.');
      });
  }

  onOpenEditHost(row: any) {
    this.showAddButton = false;
    this.showUpdateButton = true;
  }

  onOpenAddHost() {
    this.showAddButton = true;
    this.showUpdateButton = false;
  }

  onUpdateHost() {

  }
}
