import { Component } from '@angular/core';
import {FormBuilder, FormGroup, Validators} from "@angular/forms";
import {Router} from "@angular/router";
import {ApiService} from "../../../shared/api.service";

@Component({
  selector: 'app-login',
  templateUrl: './login-tailwindcss.component.html',
  styleUrls: ['./login-tailwindcss.component.css']
})
export class LoginTailwindcssComponent {
  loginForm: FormGroup;

  constructor(private fb: FormBuilder,private api: ApiService,
              private router:Router) {
    this.loginForm = this.fb.group({
      username: ['', Validators.required],
      password: ['', Validators.required]
    });
  }

  onSubmit() {
    if (this.loginForm.valid) {
      console.log('Username:', this.loginForm.value.username);
      console.log('Password:', this.loginForm.value.password);
    }
    this.login()
  }

  login() {
    console.log(this.loginForm.value)
    this.api.post("http://localhost:8080/api/v1/auth/login", this.loginForm.value).subscribe(
      (res: any) => {
        console.log(res)
        if (res && res.token) {
          const role = res.roles[0];
          localStorage.setItem('token', res.token);
          localStorage.setItem('role', role);
          this.router.navigate([{ outlets: { main: ["homeDash"] } }]);
        }},
      err => {
        alert("Wrong username or password. Try again!")
        // @ts-ignore
        this.router.navigate(['/homeDash'], { outlets: { main: null } });
      });
  }
}
