import {Component} from '@angular/core';
import {FormBuilder, FormGroup} from "@angular/forms";
import {ApiService} from "../../../shared/api.service";
import {Router} from "@angular/router";

@Component({
  selector: 'app-signup',
  templateUrl: './signup.component.html',
  styleUrls: ['./signup.component.css']
})
export class SignupComponent {

  formSignup!: FormGroup;

  constructor(private fb: FormBuilder, private api: ApiService, private router: Router) {
    this.formSignup = this.fb.group({
      username: [''],
      email: [''],
      password: ['']
    });
  }

  singUp() {
    const payload = {
      username: this.formSignup.value.username,
      email: this.formSignup.value.email,
      password: this.formSignup.value.password,
      roles: ['user']
    }
    return this.api.post('http://localhost:8080/api/v1/auth/signup', payload)
      .subscribe(res => {
        console.log(res);
        this.formSignup.reset();
        alert('Sign up successful.');
        this.router.navigate(['login']);
      }, err => {
        alert('An error has occurred. Try again.');
      });
  }
}
