import {Injectable} from '@angular/core';
import {HttpClient, HttpHeaders} from "@angular/common/http";
import {map} from "rxjs";

@Injectable({
  providedIn: 'root'
})
export class ApiService {

  constructor(private http: HttpClient) {
  }

  get(url: string) {
    return this.http.get(url, {headers: this.getHttpHeader()})
      .pipe(map((response: any) => {
        return response;
      }));
  }

  getReadingsBySensorId(url: string, id: string) {
    return this.http.get(url + '?sensorId=' + id, {headers: this.getHttpHeader()})
      .pipe(map((response: any) => {
        return response;
      }));
  }

  post(url: string, data: any) {
    return this.http.post(url, data, {headers: this.getHttpHeader()})
      .pipe(map((response: any) => {
        return response;
      }));
  }

  delete(url: string, id: string) {
    return this.http.delete(url + '/' + id, {headers: this.getHttpHeader()})
      .pipe(map((response: any) => {
        return response;
      }));
  }

  put(url: string, id: string, data: any) {
    return this.http.put(url + '/' + id, data, {headers: this.getHttpHeader()})
      .pipe(map((response: any) => {
        return response;
      }));
  }

  private getHttpHeader() {
    return {'Authorization': 'Bearer ' + localStorage.getItem('token')};
  }
}
