import { Injectable } from '@angular/core';
import {ReadingPayload} from "../../../../projects/generated-api/src";

@Injectable({
  providedIn: 'root'
})
export class MapperService {

  iconMapper = new Map<String, String>([
    ["SOLAR_RADIATION", "sunny"],
    ["SOIL_MOISTURE", "water"],
    ["","unknown"]
  ]);

  unitMapper = new Map<String, String>([
    ["SOLAR_RADIATION", "W/m2"],
    ["SOIL_MOISTURE", "vwc"],
    ["","unknown"]
  ]);

  unitHashMapper = new Map<String, String>([
    ["SOIL_TEMPERATURE", "&#176;"],
    ["SOIL_MOISTURE", "&#37;"],
    ["","unknown"]
  ]);

  typeMapper = new Map<String, String>([
    ["AVG", "Durchschnitt"],
    ["SUM", "Totale Summe"],
    ["","unknown"]
  ]);


  getSymbolFromError(error: ReadingPayload.SensorErrorEnum): string {
    return error === ReadingPayload.SensorErrorEnum.NOERROR ? "circle" : "triangle";
  }


  constructor() { }
}
