import { Injectable } from '@angular/core';

export enum LogLevel {
  OFF = 0,
  ERROR = 1,
  WARNING = 2,
  INFO = 3,
  DEBUG = 4,
  LOG = 5
}
@Injectable({
  providedIn: 'root'
})
export class MyLoggerServiceService {
  private logLevel: LogLevel = LogLevel.OFF;
  private topic:String="NULL"
  constructor() { }

  setLevel(level: LogLevel): void {
    this.logLevel = level;
  }

  setTopic(topic: String): void {
    this.topic=topic;
  }



  error(s:any,...message: any[]): void {
    if (this.logLevel >= LogLevel.ERROR) {
      let topic = this.topic !== "NULL" ? this.topic : "";
      console.error(topic+": "+s,message);
    }
  }

  warn(s:any,...message: any[]): void {
    if (this.logLevel >= LogLevel.WARNING) {
      let topic = this.topic !== "NULL" ? this.topic : "";
      console.warn(topic+": "+s,message);
    }
  }

  info(s:any,...message: any[]): void {
    if (this.logLevel >= LogLevel.INFO) {
      let topic = this.topic !== "NULL" ? this.topic : "";
      console.info(topic+": "+s,message);
    }
  }

  debug(s:any,...message: any[]): void {
    if (this.logLevel >= LogLevel.DEBUG) {
      let topic = this.topic !== "NULL" ? this.topic : "";
      console.debug(topic+": "+s,message);
    }
  }

  log(...args: any[]): void {
    if (this.logLevel >= LogLevel.LOG) {
      let prefix = this.topic !== "NULL" ? this.topic : "";
      console.log(prefix,args);
    }
  }
}
